pico-8 cartridge // http://www.pico-8.com
version 8
__lua__
--wave stuff
w1={} --wave1
w2={} --wave2
w3={} --wave3
f1=1 --frequency of wave1
a1=7 --amplitude of wave1
f2=1 --frequency of wave2
a2=7 --amplitude of wave2
maxamp=10 --max wave amplitude 
maxfreq=4 --max wave frequency
s_wave=0 --selected wave

selector={}
selector.pos=22
selector.pos1=22
selector.pos2=22
selector.targ=0

targets={}
t_flash=0

levels={}
level=1

cam_time=0

smoke = {}

win_time=-1

function make_levels()
--big ass function that makes
--all the levels

--make level 1
 targs={}--targets
 --target 1
 targs[1]={}
 targs[1].x=50
 targs[1].y=-10
 targs[1].hit=0
 levels[1]=targs--add to levels
 
--make level 2
 targs={}
 --target 1
 targs[1]={}
 targs[1].x=60
 targs[1].y=0
 levels[2]=targs
 
--make level 3
 targs={}
 --target 1
 targs[1]={}
 targs[1].x=50
 targs[1].y=-20
 --lvl 3 target 2
 --[[targs[2]={}
 targs[2].x=99
 targs[2].y=19]]
 levels[3]=targs
 
--make level 4
 targs={}
 --target 1
 targs[1]={}
 targs[1].x=30
 targs[1].y=-15
 levels[4]=targs
 
 --make level 5
 targs={}--targets
 --target 1
 targs[1]={}
 targs[1].x=35
 targs[1].y=-10
 targs[1].hit=0
 --target 2
 targs[2]={}
 targs[2].x=57
 targs[2].y=-9
 targs[2].hit=0
 levels[5]=targs--add to levels
 
--make level 6
 targs={}--targets
 --target 1
 targs[1]={}
 targs[1].x=30
 targs[1].y=-0
 targs[1].hit=0
 --target 2
 targs[2]={}
 targs[2].x=60
 targs[2].y=0
 targs[2].hit=0
 --target 3
 targs[3]={}
 targs[3].x=99
 targs[3].y=0
 targs[3].hit=0
 levels[6]=targs--add to levels
 
--make level 7
 targs={}--targets
 --target 1
 targs[1]={}
 targs[1].x=30
 targs[1].y=-7
 targs[1].hit=0
 --target 2
 targs[2]={}
 targs[2].x=99
 targs[2].y=-7
 targs[2].hit=0
 levels[7]=targs--add to levels

--make level 8
 targs={}
 --target 1
 targs[1]={}
 targs[1].x=60
 targs[1].y=-10
 --target 2
 targs[2]={}
 targs[2].x=70
 targs[2].y=-12
 levels[8]=targs
 
--make level 9
	targs={}
	--target 1
	targs[1]={}
	targs[1].x=27
	targs[1].y=-15
	--target 2
	targs[2]={}
	targs[2].x=90
	targs[2].y=14
	levels[9]=targs
 
--make level 10
	targs={}
	--target 1
	targs[1]={}
	targs[1].x=40
	targs[1].y=-5
	--target 2
	targs[2]={}
	targs[2].x=60
	targs[2].y=-5
	--target 3
	targs[3]={}
	targs[3].x=80
	targs[3].y=-5
	levels[10]=targs
	
--make level 11
 targs={}
 --target 1
 targs[1]={}
 targs[1].x=50
 targs[1].y=10
 --target 2
 targs[2]={}
 targs[2].x=60
 targs[2].y=0
 --target 3
 targs[3]={}
 targs[3].x=70
 targs[3].y=-10
 levels[11]=targs
 
--make level 12
 targs={}
 --target 1
 targs[1]={}
 targs[1].x=18
 targs[1].y=-9
 --target 2
 targs[2]={}
 targs[2].x=31
 targs[2].y=-3
 --target 3
 targs[3]={}
 targs[3].x=43
 targs[3].y=-9
 levels[12]=targs
 
--make lvl 13 
 targs={}
 --target 1
 targs[1]={}
 targs[1].x=45
 targs[1].y=-12
 --target 2
 targs[2]={}
 targs[2].x=63
 targs[2].y=-4
 --target 3
 targs[3]={}
 targs[3].x=83
 targs[3].y=-12
 levels[13]=targs
 
 --make lvl 14 
 targs={}
 --target 1
 targs[1]={}
 targs[1].x=5
 targs[1].y=-15
 --target 2
 targs[2]={}
 targs[2].x=50
 targs[2].y=15
 levels[14]=targs
 
 --make lvl 15
 targs={}
 --target 1
 targs[1]={}
 targs[1].x=40
 targs[1].y=-20
 --target 2
 targs[2]={}
 targs[2].x=50
 targs[2].y=-20
 --ltarget 3
 targs[3]={}
 targs[3].x=60
 targs[3].y=-20
 --target 4
 targs[4]={}
 targs[4].x=70
 targs[4].y=-20
 --target 5
 targs[5]={}
 targs[5].x=80
 targs[5].y=-20
 levels[15]=targs
end

function win_timer()
--timer to transition
--to the win screen
 if win_time>0 then 
  win_time-=1
 end
 if win_time==0 then
 	win_init()
 end
end

function update_targets()
 --check if targets hit
 for targ in all(targets) do
  if (targ.y+1>w3[targ.x-1]
   and w3[targ.x-1]>targ.y-1)  
  or (targ.y+1>w3[targ.x]
   and w3[targ.x]>targ.y-1)
  or (targ.y+1>w3[targ.x+1]
   and w3[targ.x+1]>targ.y-1)
  then
   if targ.hit==0 then 
    sfx(63,3) 
   end
   targ.hit=1
  else
  	if targ.hit==1 then
  	 sfx(62,3)
  	end
  	targ.hit=0
  end
 end
 --toggle flash
 t_flash=(t_flash+1)%6
end

function check_hits()
--[[
returns true if all targets
are hit, false if any 
are not hit
]] 
 for targ in all(targets) do
  if targ.hit==0 then return false end
 end
 return true
end

function fire()
 if check_hits() then
  sfx(61)
  cam_time=10 --screenshake
  for targ in all(targets) do
   smoke_poof(targ.x,targ.y,3,4,6)
   smoke_poof(targ.x,targ.y,3,15,4)
  end
  
  level+=1
  if level>#levels then
   music(-1)
   sfx(58,3)
   win_time=120
  end
  targets=levels[level]
  reset_waves()
 else
  sfx(59)
 end
end

function reset_waves()
 f1=1 --frequency of wave1
 a1=7 --amplitude of wave1
 f2=1 --frequency of wave2
 a2=7 --amplitude of wave2
end
 
function update_waves()
 local x=0 --base for wave func
 for i=1,128 do
 	x=i/100
  --update wave1
  w1[i]=(cos(x*f1)*a1)
  
  --update wave2
  w2[i]=(cos(x*f2)*a2)

  --update composite wave
  w3[i]=(cos(x*f1)*a1)
    +(cos(x*f2)*a2)
 end
end

function make_smoke(x,y,init_size,col)
 local s = {}
 s.x=x
 s.y=y
 s.col=col
 s.width = init_size
 s.width_final = init_size + rnd(3)+1
 s.t=0
 s.max_t = 10+rnd(10)
 s.dx = (rnd(.8)-.4)
 s.dy = (rnd(.8)-.4)
 s.ddy = -.02
 add(smoke,s)
 return s
end

function smoke_poof(x,y,i_s,col,n)
	--make a poof of n smokes
	for i=0,n do
	 make_smoke(x,y,i_s,col)
	end
end

function move_smoke(sp)
 if (sp.t > sp.max_t) then
  del(smoke,sp)
 end
 if (sp.t > sp.max_t) then
  sp.width +=1
  sp.width = min(sp.width,sp.width_final)
 end
 sp.x = sp.x + sp.dx
 sp.y = sp.y + sp.dy
 sp.dy= sp.dy+ sp.ddy
 sp.t = sp.t + 1
end

function update_selector()
 if s_wave==0 then
  selector.targ=21
  if selector.pos>selector.targ then
   selector.pos2=selector.pos1
   selector.pos1=selector.pos
   selector.pos=selector.pos-((selector.pos-selector.targ)/2)
  end
 end
 if s_wave==1 then
  selector.targ=63
  if selector.pos<selector.targ then
   selector.pos2=selector.pos1
   selector.pos1=selector.pos
   selector.pos=selector.pos+((selector.targ-selector.pos)/2)
  end
 end
end

--drawing functions
function draw_selector()
 --circ(10,selector.pos,5,7)
 x1=3
 y1=selector.pos2-15
 x2=126
 y2=selector.pos2+15
 col=4
 line(x1,y1,x1+5,y1,col)
 line(x1,y1,x1,y1+5,col)
 line(x2,y1,x2-5,y1,col)
 line(x2,y1,x2,y1+5,col)
 line(x1,y2,x1+5,y2,col)
 line(x1,y2,x1,y2-5,col)
 line(x2,y2,x2-5,y2,col)
 line(x2,y2,x2,y2-5,col)
 
 x1=3
 y1=selector.pos1-15
 x2=126
 y2=selector.pos1+15
 col=15
 line(x1,y1,x1+5,y1,col)
 line(x1,y1,x1,y1+5,col)
 line(x2,y1,x2-5,y1,col)
 line(x2,y1,x2,y1+5,col)
 line(x1,y2,x1+5,y2,col)
 line(x1,y2,x1,y2-5,col)
 line(x2,y2,x2-5,y2,col)
 line(x2,y2,x2,y2-5,col)
 
 x1=3
 y1=selector.pos-15
 x2=126
 y2=selector.pos+15
 col=7
 line(x1,y1,x1+5,y1,col)
 line(x1,y1,x1,y1+5,col)
 line(x2,y1,x2-5,y1,col)
 line(x2,y1,x2,y1+5,col)
 line(x1,y2,x1+5,y2,col)
 line(x1,y2,x1,y2-5,col)
 line(x2,y2,x2-5,y2,col)
 line(x2,y2,x2,y2-5,col)
end

function draw_targets()
	--draw target reticles
	local t_col=8
	local f_col=14
	for targ in all(targets) do
	 rect(targ.x-2,
	      targ.y-2 +105,
	      targ.x+2,
	      targ.y+2 +105,
	      t_col)
	 pset(targ.x-3,targ.y+105,t_col)
	 pset(targ.x+3,targ.y+105,t_col)
	 pset(targ.x,targ.y+105-3,t_col)
	 pset(targ.x,targ.y+105+3,t_col)
	 
	 --if target is hit
	 if targ.hit==1 then
	  --draw extra rect
	  rect(targ.x-4,
	      targ.y-4 +105,
	      targ.x+4,
	      targ.y+4 +105,
	      f_col)
	  --flash center
	  if t_flash<3 then
	  rectfill(targ.x-1,
	      targ.y-1 +105,
	      targ.x+1,
	      targ.y+1 +105,
	      f_col)
	  end
	 end
	end
end

function draw_waves()
 --draw the waves
 local x=0 --base for wave func
 for i=2,128 do
 	x=i/100
  --draw wave1 segment
  line(i-1-1,w1[i-1]+21,
       i-1,w1[i]+21,
       14)
  --draw wave2 segment
  line(i-1-1,w2[i-1]+63,
       i-1,w2[i]+63,
       12)
  --draw composite wave segment
  line(i-1-1,w3[i-1]+105,
       i-1,w3[i]+105,
       7) 
 end
end

function outline_selected()
 --outlines the selected wave
 --call before draw_waves
 local wave=w1
 local midline=21
 local col=5
 if s_wave==0 then 
  wave=w1
  midline=21
 elseif s_wave==1 then 
  wave=w2
  midline=63
 end
 
 for i=2,128 do
 	x=i/100
  --draw wave left 1 pixel
  line(i-1-1-1,wave[i-1]+midline,
       i-1-1,wave[i]+midline,
       col)
  --draw wave right 1 pixel
  line(i-1-1+1,wave[i-1]+midline,
       i-1+1,wave[i]+midline,
       col)
  --draw wave up 1 pixel
  line(i-1-1,wave[i-1]-1+midline,
       i-1,wave[i]-1+midline,
       col)
  --draw wave down 1 pixel
  line(i-1-1,wave[i-1]+1+midline,
       i-1,wave[i]+1+midline,
       col) 
 end
end

function draw_grid(grid)
	--dev function to help
	--layout of levels
 for i=0,12 do
  line(i*10,0,i*10,127,2)
 end
 if grid==1 then
  for i=0,12 do
   line(0,i*10,127,i*10,2)
  end
 end
end

function draw_smoke(s)
 circfill(s.x,s.y+105,s.width,s.col)
end

function game_init()
 music(-1)
 mode=1
 win_time=-1
 level=1
 smoke={}
 make_levels()
	targets=levels[level]
	reset_waves()
	update_waves()
	music(0)
end

function game_update()
 --switch between waves
 if btnp(4) then
  s_wave=(s_wave+1)%2 --1>0>1>...
  sfx(60)
 end
 
 update_selector()
 
 --fire!!!
 if btnp(5) and win_time<0 then
  fire()
 end
 
 --control wave1
 if s_wave==0 then
  if btn(0) then f1+=.02 end
  if btn(1) then f1-=.02 end
  if btn(2) then a1 +=.2 end
  if btn(3) then a1 -=.2 end
 end
 
 --control wave2
 if s_wave==1 then
  if btn(0) then f2+=.02 end
  if btn(1) then f2-=.02 end
  if btn(2) then a2 +=.2 end
  if btn(3) then a2 -=.2 end
 end
 
 --clamp amplitude
 if a1>maxamp then 
  a1=maxamp 
 end
 if a1<-maxamp then 
  a1=-maxamp 
 end
 if a2>maxamp then 
  a2=maxamp 
 end
 if a2<-maxamp then 
  a2=-maxamp 
 end
 
 --clamp frequency
 if f1>maxfreq then 
  f1=maxfreq 
 end
 if f1<-maxfreq then 
  f1=-maxfreq 
 end
 if f2>maxfreq then 
  f2=maxfreq 
 end
 if f2<-maxfreq then 
  f2=-maxfreq 
 end
 
 --call update_waves
 update_waves()
 --call update targets
 update_targets()
 --tick camera time
 if cam_time>0 then cam_time-=1 end
 
 foreach(smoke, move_smoke)
 
 win_timer()
end

function game_draw()
 cls()
 
 --camera fx zone!!! oh ya!!!
 if cam_time>0 then
  --screenshake!!
  camera(rnd(6)-3,rnd(6)-3)
 else
 	camera()--no screenshake!!!
 end
 
 --shaky win screen transition
 if win_time>0 then
  local n=((60-win_time)/20)^2
  camera(rnd(n)-n/2,rnd(n)-n/2)
 end
 
 --draw helper grid
 draw_grid(0)
 
 --draw mid-lines
 line(0,21,127,21,5)
 line(0,63,127,63,5)
 line(0,105,127,105,5)
 
 --outline sleected wave
 outline_selected()
 
 --draw the waves
 draw_waves()
 
 draw_selector()
 
 --draw targets
 draw_targets()
  
 foreach(smoke, draw_smoke)
 
 --print level indicator
 print("stage",3,120,7)
 if level>#levels then
  print("",27,120,7) 
 else
  print(level,27,120,7)
 end
 --white frames at strt of 
 --screenshake frames
 if cam_time>7 then
  rectfill(0,0,127,127,7)
 end
end

function title_init()
	mode=0
	music(20)
	cls()
end

function title_update()
 if btnp(5) then
  game_init()
 end
end

function title_draw()
 --cls()
 print(" hyperposition ", 24, 8)
 print("controls:", 46, 32)
 print("arrows to alter freq / amplitude", 0, 42)
 print("z to switch wave", 64-32, 50)
 print("x to lock solution", 64-38, 58)
 print("press x to begin",32, 100, 7)
 print("born at global game jam 2017", 8, 122)
end

function win_init()
 camera()
 cls()
 sfx(-1,3)
 music(22)
 mode=3
end

function win_update()
	if btnp(5) then
		title_init()
	end
end

function win_draw()
	print("all stages complete",64-38,64,7)
end

function _init()
 title_init()
end

function _update()
 if mode==0 then
  title_update()
 elseif mode==1 then
 	game_update()
 else
 	win_update()
 end
end

function _draw()
 if mode==0 then
  title_draw()
 elseif mode==1 then
 	game_draw()
 else
 	win_draw()
 end
end
__gfx__
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00700700000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00077000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00077000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00700700000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000

__gff__
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
__map__
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
__sfx__
001800000035300303046030035334640000000035300000003530000004603000003464000000046030000000353000000460300353346400000000353286030035300000046030000034640000000035328643
011800000235300303046350035334640000000463500000003630000004635000003464000000046350000000363000000463500363346400000004635286030036300000046350000034640000000463528643
011800003464000303046350035334640000000463500000346400000004635003033464000000046350000034640003530463500363346400000004635286033464000000046350035334640000000463500353
011800003464000303003530035334640000000463500000346400000004635003533464000000046350000034640003530035300363346400000004635286033464000000046350035334640000000463528643
010c00000035300303003530035334635000003463500000346400000004635003533463500000346350000000353003530035300363346350000034635286033464000000046350035334635000000463534643
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
01180000094550923509235092350945509235092350923509455092350923509235094550923509235092350a4550a2350a2350a2350a4550a2350a2350a23507452072350e2060a45409455074520545204450
01180000094550923509235092350945509235092350923509455092350923509235094550923509235092350a4550a2350a2350a2350a4560a2360a2350a2350e4560e2360e2360223611456112350c2350e235
01180000094550923509235092350945509235092350923509455092350923509235094550923509235092350a4550a2350a2350a2350a4550a2350a2350a235074550723507235072350a4550a2350a2350a235
01180020154550e2350d23509235103400e2350d235092350e45509235152350923511340092351523509235164551c2351d2350a235133401c235113400a2351345511235102350723515340112351023516340
01180000154550e2350d23509235346400e2350d235092350e45509235152350923534640092351523509235164551c2351d2350a235346401c2351d2350a2351345511235102350723502353023531023504353
011800000245002710027100244002450027100445002710054500271002710054400545002710027100271007450027100271007440074500271004450027100445002710027100a45409455074520545204450
01180000021750215502155027551a5011a5211a5511a5310217502155021550275500000000000000000000021750215502155027551a5411a5211a5511a5310217502155021550275500000000000000000000
011800200445504235042351053504455042352823128231044550423504235105350445510535262312423105455052350523505535264212423026231292300245502235022350e535004550c5352923028231
0118000004455102351023510635044551021110235106350445510235102351063504455106350e2350c23505455112351123511635024250c6330e23111233024560e4361a4560e436004520c4321d43211432
011400000e7520f71115752157111675214711137521571115752127111175214711137520f711107520e7110e7110e7210e7310e7310e7710e7720250502506025751a575000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
01200000105302b210135302921011530212122155221232105302b210135322921011530262100e53028210105302b21013532292101153021212215522123210530132101353216210165300e2100e53210210
01200020105302b210135302921011530282121c21028212105302b210135322921011530262100e53028200105302b2101353229210115301c2121a5221823210530132101353216210165301f2101d5321c210
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
011000201522017240182201524017220182401522017240182201524017220182402224022240222402224017220182401522017240182201524017220182401522017240182201524017220182401522017240
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
012000001a1041a1011d1011d1011d1010000000000000001f5141f5511a5211a5111a5211a521000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
011f0000111041110115101151011510100000000000000021514215511d5211d5111d5211d521000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
016000001a1141a1311d1211d1111d1311d1111d10526101221042210126101261012610126105261012610122104221012210026101261012610126101261012610126100000000000000000000000000000000
016000001111411131151211511115131151110000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000961008610076100961008610086100762007620076200762007620086200863007630076300763007630076300864009640096400964009640096400965009650096500965008650086600866008660
000400001016004160101001016004160001000010000100001000010000100001000010000100001000010000100001000010000100001000010000100001000010000100001000010000100001000010000100
000600000714024140071000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00080000033703d65039650156500d630086300562003610016100161001600016000160001600016000160001600006000060000600006000060000600006000060000600006000060000600006000060000600
000300001c130121500a1500815007130071300010000100001000010000100001000010000100001000010000100001000010000100001000010000100001000010000100001000010000100001000010000100
000300000f150121501a1502a150166000d0000c0000c000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
__music__
00 400a4943
00 410a2846
01 000a685c
00 010a4344
01 010a145e
00 000a145e
00 01091444
00 010f1444
00 010f1555
00 010a2829
02 01082829
00 01284344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
01 0e282944
02 0e686944
06 11262767
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344

